makeup_market/apps/account/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path
from django.views.generic.base import TemplateView
from makeup_market.apps.orders.views import user_orders

from . import views
from .forms import PwdResetConfirmForm, PwdResetForm, UserLoginForm

app_name = "account"

urlpatterns = [
    path(
        "login/",
        auth_views.LoginView.as_view(template_name="account/login.html", form_class=UserLoginForm),
        name="login",
    ),
    path("logout/", auth_views.LogoutView.as_view(next_page="/account/login/"), name="logout"),
    path("register/", views.account_register, name="register"),
    path("activate/<slug:uidb64>/<slug:token>/", views.account_activate, name="activate"),
    path(
        "password_reset/",
        auth_views.PasswordResetView.as_view(
            template_name="account/password_reset/password_reset_form.html",
            success_url="password_reset_email_confirm",
            email_template_name="account/password_reset/password_reset_email.html",
            form_class=PwdResetForm,
        ),
        name="pwdreset",
    ),
    path(
        "password_reset_confirm/<uidb64>/<token>/",
        auth_views.PasswordResetConfirmView.as_view(
            template_name="account/password_reset/password_reset_confirm.html",
            success_url="/account/password_reset_complete/",
            form_class=PwdResetConfirmForm,
        ),
        name="password_reset_confirm",
    ),
    path(
        "password_reset/password_reset_email_confirm/",
        TemplateView.as_view(template_name="account/password_reset/reset_status.html"),
        name="password_reset_done",
    ),
    path(
        "password_reset_complete/",
        TemplateView.as_view(template_name="account/password_reset/reset_status.html"),
        name="password_reset_complete",
    ),
    # User Dashboard
    path("dashboard/", views.dashboard, name="dashboard"),
    path("profile/edit/", views.edit_details, name="edit_details"),
    path("profile/delete_user/", views.delete_user, name="delete_user"),
    path(
        "profile/delete_confirm/",
        TemplateView.as_view(template_name="account/dashboard/delete_confirm.html"),
        name="delete_confirm",
    ),
    path("user_orderes/", views.user_orders, name="user_orders"),
    # addresses
    path("addresses/", views.view_address, name="addresses"),
    path("add_address/", views.add_address, name="add_address"),
    path("address/edit/<slug:id>/", views.edit_address, name="edit_address"),
    path("address/delete/<slug:id>/", views.delete_address, name="delete_address"),
    path("address/set_default/<slug:id>/", views.set_default, name="set_default"),
    # Wish list
    path("wishlist/", views.wishlist, name="wishlist"),
    path("wishlist/add_to_wishlist/<int:id>", views.add_to_wishlist, name="user_wishlist"),
]

makeup_market/apps/basket/urls.py
from django.urls import path

from . import views

app_name = "basket"

urlpatterns = [
    path("", views.basket_summary, name="basket_summary"),
    path("add/", views.basket_add, name="basket_add"),
    path("delete/", views.basket_delete, name="basket_delete"),
    path("update/", views.basket_update, name="basket_update"),
]

makeup_market/apps/catalogue/urls.py
from django.urls import path

from . import views

app_name = "catalogue"

urlpatterns = [
    path("", views.product_all, name="home"),
    path("<slug:slug>", views.product_detail, name="product_detail"),
    path("shop/<slug:category_slug>/", views.category_list, name="category_list"),
]

makeup_market/urls.py
import debug_toolbar
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("makeup_market.apps.catalogue.urls", namespace="catalogue")),
    path("basket/", include("makeup_market.apps.basket.urls", namespace="basket")),
    path("checkout/", include("makeup_market.apps.checkout.urls", namespace="checkout")),
    path("account/", include("makeup_market.apps.account.urls", namespace="account")),
    path("social-auth/", include("social_django.urls", namespace="social")),
    path("orders/", include("makeup_market.apps.orders.urls", namespace="orders")),
    path("__debug__/", include(debug_toolbar.urls)),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

makeup_market/apps/catalogue/models.py
from django.conf import settings
from django.db import models
from django.db.models.fields import related
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from mptt.models import MPTTModel, TreeForeignKey


class Category(MPTTModel):
    """
    Category table implemented with MPTT.
    """

    name = models.CharField(
        verbose_name=("Category name"), help_text=_("Required and unique"), max_length=255, unique=True
    )
    slug = models.SlugField(verbose_name=_("Category Safe URL"), max_length=255, unique=True)
    parent = TreeForeignKey("self", on_delete=models.CASCADE, null=True, blank=True, related_name="children")
    is_active = models.BooleanField(default=True)

    class MPTTMeta:
        order_insertion_by = ["name"]

    class Meta:
        verbose_name = _("Category")
        verbose_name_plural = _("Categories")

    def get_absolute_url(self):
        return reverse("catalogue:category_list", args=[self.slug])

    def __str__(self):
        return self.name


class ProductType(models.Model):
    """
    ProductType tabel will provide a list of different types
    of products that are for sale.
    """

    name = models.CharField(
        verbose_name=_("Product name"), help_text=_("Required"), max_length=255, unique=True, db_index=True
    )
    is_active = models.BooleanField(default=True, unique=True)

    class Meta:
        verbose_name = _("Product type")
        verbose_name_plural = _("Product Types")

    def __str__(self):
        return self.name


class ProductSpecification(models.Model):
    """
    The Product Specification table contains product
    specification or features for the product types.
    """

    product_type = models.ForeignKey(ProductType, on_delete=models.RESTRICT)
    name = models.CharField(verbose_name=_("Name"), help_text=_("Requried"), max_length=255)

    class Meta:
        verbose_name = _("Product Specification")
        verbose_name_plural = _("Product Specifications")

    def __str__(self):
        return self.name


class Product(models.Model):
    """
    The Product table contains all the product items.
    """

    product_type = models.ForeignKey(ProductType, on_delete=models.RESTRICT)
    category = models.ForeignKey(Category, on_delete=models.RESTRICT)
    title = models.CharField(verbose_name=_("Title"), help_text=_("Required"), max_length=255)
    description = models.TextField(verbose_name=_("Description"), help_text=_("Not Required"), blank=True)
    slug = models.SlugField(max_length=255)
    regular_price = models.DecimalField(
        verbose_name=_("Regular Price"),
        help_text=_("Maximum 9999.99"),
        error_messages={"name": {"max_length": _("The price must be between 0 and 9999.99")}},
        max_digits=6,
        decimal_places=2,
    )
    descount_price = models.DecimalField(
        verbose_name=_("Descount Price"),
        help_text=_("Maximum 9999.99"),
        error_messages={"name": {"max_length": _("The price must be between 0 and 9999.99")}},
        max_digits=6,
        decimal_places=2,
    )
    is_active = models.BooleanField(
        verbose_name=_("Product visibility"), help_text=_("Change product visibility"), default=True
    )
    created_at = models.DateTimeField(_("Created at"), auto_now_add=True, editable=False)
    updated_at = models.DateTimeField(_("Updated at"), auto_now=True)
    users_wishlist = models.ManyToManyField(settings.AUTH_USER_MODEL, related_name="user_wishlist", blank=True)

    class Meta:
        ordering = ("-created_at",)
        verbose_name = _("Product")
        verbose_name_plural = _("Products")

    def get_absolute_url(self):
        return reverse("catalogue:product_detail", args=[self.slug])

    def __str__(self):
        return self.title


class ProductSpecificationValue(models.Model):
    """
    The product specification value table holds each of the
    products individual specification or bespoke feature
    """

    product = models.ForeignKey(Product, on_delete=models.CASCADE)
    specification = models.ForeignKey(ProductSpecification, on_delete=models.RESTRICT)
    value = models.CharField(
        verbose_name=_("Value"), help_text=_("Product specification value (maximum of 255 words)"), max_length=255
    )

    class Meta:
        verbose_name = _("Product Specification Value")
        verbose_name_plural = _("Product Specification values")

    def __str__(self):
        return self.value


class ProductImage(models.Model):
    """
    The product image table
    """

    product = models.ForeignKey(Product, on_delete=models.CASCADE, related_name="product_image")
    image = models.ImageField(
        verbose_name=_("Image"),
        help_text=_("Upload a product image"),
        upload_to="images/",
        default="images/default.png",
    )
    alt_text = models.CharField(
        verbose_name=_("Alturnative text"),
        help_text=_("Please add alturnative text"),
        max_length=255,
        null=True,
        blank=True,
    )
    is_feature = models.BooleanField(default=False)
    created_at = models.DateTimeField(auto_now_add=True, editable=False)
    updated_at = models.DateTimeField(auto_now=True)

    class Meta:
        verbose_name = _("Product image")
        verbose_name_plural = _("Product images")

makeup_market/apps/catalogue/views.py
from django.shortcuts import get_object_or_404, render

from .models import Category, Product

# Create your views here.


def product_all(request):
    products = Product.objects.prefetch_related("product_image").filter(is_active=True)
    return render(request, "catalogue/index.html", {"products": products})


def product_detail(request, slug):
    product = get_object_or_404(Product, slug=slug, is_active=True)
    return render(request, "catalogue/single.html", {"product": product})


def category_list(request, category_slug=None):
    category = get_object_or_404(Category, slug=category_slug)
    products = Product.objects.filter(
        category__in=Category.objects.get(slug=category_slug).get_descendants(include_self=True)
    )
    return render(request, "catalogue/category.html", {"category": category, "products": products})

templates/catalogue/category.html
{% extends '../base.html' %}
{% block title %}
{{category.name}}
{% endblock  %}

{% block content %}
<div class="container" style="max-width: 1000px">
    <div class="col-12">
        <h1 class="h2">{{ category.name|title}}</h1>
    </div>
    <div class="col-12 d-flex justify-content-between">
        <div><b>Popular</b> product purchased</p>
    </div>
    <hr />
</div>
<div class="container">
    <div class="row">
        <div class="album">
                {% if not products %}
                    <div  class="col-12"> There are no currently active products <a href="{% url 'catalogue:home' %}">Home</a></div>
                {% else %}
                    <div class="row row-cols-1 row-cols-sm-2 row-cols-md-5 g-3">
                        {% for product in products %}
                            <div class="col">
                                <div class="card border-0">
                                    {% for image in product.product_image.all  %}
                                        {% if image.is_feature %}
                                            <img class="img-fluid" alt="{{image.alt_text}}" src="{{ image.image.url }}">
                                        {% endif %}
                                    {% endfor %}
                                    <div class="card-body px-0">
                                        <p class="card-text">
                                            <a class="text-dark text-decoration-none"
                                                href="{{ product.get_absolute_url }}">{{ product.title }}</a>
                                        </p>
                                        <div class="d-flex justify-content-between align-items-center">
                                            <small class="text-muted fw-bold">£{{product.regular_price}}</small>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        {% endfor %}
                    </div>
                {% endif %}  
        </div>
    </div>
</div>

{% endblock  %}

templates/catalogue/index.html
{% extends 'base.html' %}
{% block title %}Home | Makeup Market{% endblock  %}

{% block content %}
<main>
  <div class="container">
    <div class="alert alert-primary fw600 rounded-0 border-0 py-3" role="alert">
      <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-info-circle me-2"
        viewBox="0 0 16 16">
        <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z" />
        <path
          d="M8.93 6.588l-2.29.287-.082.38.45.083c.294.07.352.176.288.469l-.738 3.468c-.194.897.105 1.319.808 1.319.545 0 1.178-.252 1.465-.598l.088-.416c-.2.176-.492.246-.686.246-.275 0-.375-.193-.304-.533L8.93 6.588zM9 4.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0z" />
      </svg>
      COVID-19 - <u>Click here for our latest updates</u> on our stores, website and contact centre. Thank you for
      your patience and support.
    </div>
    <div class="container">
      <div class="row">
        <div class="album py-5">
          <div class="pb-3">
            <h1 class="h3">Popular</h1>
          </div>
          {% if not products %}

            <div class="col-12">There are currently no products active</div>
          {% else %}
            <div class="row row-cols-1 row-cols-sm-2 row-cols-md-5 g-3">
            {% for product in products %}
              <div class="col">
                <div class="card border-0">
                  {% for image in product.product_image.all  %}
                    {% if image.is_feature %}
                        <img class="img-fluid" alt="{{image.alt_text}}" src="{{ image.image.url }}">
                    {% endif %}
                  {% endfor %}
                  <div class="card-body px-0">
                    <p class="card-text">
                      <a class="text-dark text-decoration-none"
                        href="{{ product.get_absolute_url }}">{{ product.title|slice:":50" }}...</a>
                    </p>
                    <div class="fw-bold">£{{product.regular_price}}</div>
                  </div>
                </div>
              </div>
            {% endfor %}
            </div>
          {% endif %}
          
          
        </div>
      </div>
    </div>
</main>

{% endblock  %}

templates/catalogue/single.html
{% extends '../base.html' %}
{% load static %}
{% block stylesheet %}
   {% static 'store/css/store.css' %}
{% endblock  %}
{% block title %}
{{product.title}}
{% endblock  %}
{% block content %}

<div class="container">
    <div class="row g-3">
        {% if messages %}
            <div class="alert alert-warning" alert-{{ messages.tags }} role="alert">
                {% for message in messages  %}
                    {{ message|safe }} - <a href="{% url 'account:wishlist' %}" class="alert-link">Wishlist</a>.
                {% endfor %}
            </div>
        {% endif %}
        <div class="col-md-5 ps-3 col-lg-5 order-md-last p-0 order-1">
            <div class="d-grid gap-2">

                <div class="d-flex d-flex-inline justify-content-between">
                    <div><span class="h2">£{{ product.regular_price }}</span>
                        <p class="text-muted">includes tax</p>
                    </div>
                    <div class="">
                        <label for="select">Qty</label>
                        <select id="select" class="h6 store-select-dropdown">
                            <option value="1">1</option>
                            <option value="2">2</option>
                            <option value="3">3</option>
                            <option value="4">4</option>
                        </select>
                    </div>
                </div>
                <hr>
                <button type="button" id="add-button" value="{{product.id}}" class="btn btn-success fw500">Add to
                    basket</button>
                <a href="{% url 'account:user_wishlist' product.id %}" class="btn btn-light fw-500" role="button" aria-disabled="true">Add to Wish List</a>
            </div>
        </div>
        <div class="col-md-7 col-lg-7 p-0">
            <div class="card mb-3 border-0">
                <div class="row g-0">
                    <div class="col-md-12">
                        <div class="card-body p-1">
                            <h1 class="mb-0 h2 pe-4 pb-4">{{ product.title }}</h1>
                            <div class="bg-light">
                                {% for image in  product.product_image.all %}
                                    {% if image.is_feature %}
                                        <img class="img-fluid mx-auto d-block" width="200px"
                                        alt="{{ image.alt_text}}" src="{{ image.image.url }}">
                                    {% else %}
                                        <img class="img-fluid d-block-inline pt-3" width="100px" alt="{{ image.alt_text }}" src="{{ image.image.url}}">
                                    {% endif %}
                                {% endfor %}
                            </div>
                        </div>

                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).on('click', '#add-button', function (e) {
        e.preventDefault();
        $.ajax({
            type: 'POST',
            url: '{% url "basket:basket_add" %}',
            data: {
                productId: $('#add-button').val(),
                productQty: $('#select option:selected').val(),
                csrfmiddlewaretoken: "{{csrf_token}}",
                action: 'post'
            },
            success: function (json) {
                document.getElementById("basket-qty").innerHTML = json.qty
            },
            error: function (xhr, errmsg, err) {}
        });
    })
</script>
{% endblock  %}